#include <stdint.h>
#include <assert.h>
#include <vector>
#include <string>
#include <jni.h>
#include "UserData.h"
#include "Friend.h"
#include <signal.h>
#include "SocialJNI.h"
#include "Lang.h"
#include "DownloadUI.h"
#include "LoginUI.h"
#include "Comment.h"
#include "ShareWeiboUI.h"
#include "app/item/RMBItem.h"
#include "tms/xconf/TableConfigs.h"
#include <unordered_map>

JNIEXPORT jobjectArray JNICALL Java_tms_xconfutil_XConfUtil_getRMBItems(
		JNIEnv *env, jclass clz) {

	jclass classRMBItem = env->FindClass(env, "tms/xconfuitl/RMBItem");

	jmethodID construct = env->GetMethodID(env, cls, "<init>",
			"(ILjava/lang/String;IILjava/lang/String;)V");
	if (NULL == construct)
		return NULL;

	const unordered_map<int, const tms::xconf::IdConf *>& rmbItemCfg =
			tms::xconf::TableConfigs::getTableConf<RMBItem>();

	jobjectArray outJNIArray = env->NewObjectArray(rmbItemCfg.size(),
			classRMBItem, NULL);

	for (auto it = rmbItemCfg.begin(); it != rmbItemCfg.end(); ++it) {
		const RMBItem *cfg = static_cast<const RMBItem *>(it->second);
		jobject obj = env->NewObject(classRMBItem, construct, cfg->getUid(),
				cfg->name.c_str(), cfg->diamond, cfg->price,
				cfg->productId.c_str());
		env->SetObjectArrayElement(outJNIArray, it - rmbItemCfg.beein(), obj);
	}

	return outJNIArray;
}
